%bcond_with enginio
%bcond_with webengine
%bcond_with webkit

%global python3_dbus_dir %(%{__python3} -c "import dbus.mainloop; print(dbus.mainloop.__path__[0])" 2>/dev/null || echo "%{python3_sitearch}/dbus/mainloop")
%global py3_sipdir %{_datadir}/sip/PyQt5
%global py3_site_qt5 %{python3_sitearch}/PyQt5
%global __provides_exclude_from ^(%{_qt5_plugindir}/.*\\.so)$

Summary:       PyQt5 is a set of Python bindings for Qt5
Name:          python-qt5
Version:       5.15.9
Release:       5%{?dist}
License:       GPLv3
Url:           http://www.riverbankcomputing.com/software/pyqt/
Source0:       https://pypi.python.org/packages/source/P/PyQt5/PyQt5-%{version}.tar.gz
Source1:       macros.pyqt5

BuildRequires: make chrpath findutils
BuildRequires: pkgconfig(dbus-1) pkgconfig(dbus-python) qt5-qtbase-private-devel pkgconfig(Qt5Core)
BuildRequires: pkgconfig(Qt5Bluetooth) pkgconfig(Qt5DBus) pkgconfig(Qt5Designer) pkgconfig(Qt5Gui)
BuildRequires: pkgconfig(Qt5Location) pkgconfig(Qt5Multimedia) pkgconfig(libpulse-mainloop-glib)
BuildRequires: pkgconfig(Qt5Nfc) pkgconfig(Qt5Network) pkgconfig(Qt5OpenGL) pkgconfig(Qt5Positioning)
BuildRequires: pkgconfig(Qt5Quick) pkgconfig(Qt5QuickWidgets) pkgconfig(Qt5Sensors) pkgconfig(Qt5SerialPort)
BuildRequires: pkgconfig(Qt5Sql) pkgconfig(Qt5Svg) pkgconfig(Qt5Test) pkgconfig(Qt5X11Extras)
BuildRequires: pkgconfig(Qt5Xml) pkgconfig(Qt5XmlPatterns) pkgconfig(Qt5WebChannel) pkgconfig(Qt5WebSockets)
BuildRequires: python%{python3_pkgversion}-devel python%{python3_pkgversion} python%{python3_pkgversion}-dbus
BuildRequires: %{py3_dist PyQt-builder} %{py3_dist sip}
%if %{with enginio}
BuildRequires: pkgconfig(Enginio)
%endif
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}

%description
PyQt is a set of Python v2 and v3 bindings for The Qt Company's Qt application framework and runs on 
all platforms supported by Qt including Windows, OS X, Linux, iOS and Android. PyQt5 supports Qt v5.

%package rpm-macros
Summary:        RPM macros in python-qt5
BuildArch:      noarch

%description rpm-macros
RPM macros in python-qt5.

%package -n python%{python3_pkgversion}-qt5
Summary:        Python v3 bindings for Qt5
Requires:       python%{python3_pkgversion}-qt5-base = %{version}-%{release}
Provides:       python%{python3_pkgversion}-PyQt5 = %{version}-%{release}
Provides:       python%{python3_pkgversion}-PyQt5 = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5
Python v3 bindings for Qt5.

%package -n python%{python3_pkgversion}-qt5-base
Summary:        Python v3 bindings for Qt5 base
Requires:       %{name}-rpm-macros = %{version}-%{release} python%{python3_pkgversion}-dbus
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}
%{?_sip_api:Requires: python%{python3_pkgversion}-pyqt5-sip-api(%{_sip_api_major}) >= %{_sip_api}}
Provides:       python%{python3_pkgversion}-PyQt5-base = %{version}-%{release}
Provides:       python%{python3_pkgversion}-PyQt5-base = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5-base
Python v3 bindings for Qt5 base.

%package -n python%{python3_pkgversion}-qt5-devel
Summary:        Development files for python3-qt5
Requires:       python%{python3_pkgversion}-qt5 = %{version}-%{release}
Requires:       python%{python3_pkgversion}-sip-devel
Provides:       python%{python3_pkgversion}-PyQt5-devel = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5-devel
Development files for python3-qt5.

%if %{with webengine}
%package -n python%{python3_pkgversion}-qt5-webengine
Summary:        Python v3 bindings for Qt5 WebEngine
Requires:       python%{python3_pkgversion}-qt5 = %{version}-%{release}
BuildRequires:  qt5-qtwebengine-devel

%description -n python%{python3_pkgversion}-qt5-webengine
Python v3 bindings for Qt5 WebEngine.
%endif

%if %{with webkit}
%package -n python%{python3_pkgversion}-qt5-webkit
Summary:        Python v3 bindings for Qt5 Webkit
BuildRequires:  qt5-qtwebkit-devel qt5-qtwebkit-devel
Requires:       python%{python3_pkgversion}-qt5 = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5-webkit
Python v3 bindings for Qt5 Webkit.
%endif

%prep
%autosetup -n PyQt5-%{version} -p1

%build
PATH=%{_qt5_bindir}:$PATH ; export PATH

sip-build \
  --no-make \
  --qt-shared \
  --confirm-license \
  --qmake=%{_qt5_qmake} \
  --api-dir=%{_qt5_datadir}/qsci/api/python \
  --verbose \
  --dbus=%{_includedir}/dbus-1.0/ \
  --pep484-pyi \
  --qmake-setting 'QMAKE_CFLAGS_RELEASE="%{optflags}"' \
  --qmake-setting 'QMAKE_CXXFLAGS_RELEASE="%{optflags} `pkg-config --cflags dbus-python`"' \
  --qmake-setting 'QMAKE_LFLAGS_RELEASE="%{?__global_ldflags}"'

%make_build -C build

%install
%make_install INSTALL_ROOT=%{buildroot} -C build
if [ "%{_prefix}" != "/usr" ]; then
  cp -ru %{buildroot}/usr/* %{buildroot}%{_prefix}/ || echo "Nothing to copy"
  rm -rf %{buildroot}/usr/*
fi

%py_byte_compile %{__python3} %{buildroot}%{py3_site_qt5}

find %{buildroot} -type f -name '*.so' | xargs chmod a+rx

install -p -m644 -D %{SOURCE1} \
  %{buildroot}%{_rpmconfigdir}/macros.d/macros.pyqt5
sed -i \
  -e "s|@@NAME@@|%{name}|g" \
  -e "s|@@EPOCH@@|%{?epoch}%{!?epoch:0}|g" \
  -e "s|@@VERSION@@|%{version}|g" \
  -e "s|@@EVR@@|%{?epoch:%{epoch:}}%{version}-%{release}|g" \
  %{buildroot}%{_rpmconfigdir}/macros.d/macros.pyqt5

%files rpm-macros
%{_rpmconfigdir}/macros.d/macros.pyqt5

%files -n python%{python3_pkgversion}-qt5
%if 0%{?enginio}
%{py3_site_qt5}/Enginio.*
%endif
%{py3_site_qt5}/QtBluetooth.*
%{py3_site_qt5}/QtDesigner.*
%{py3_site_qt5}/QtHelp.*
%{py3_site_qt5}/QtLocation.*
%{py3_site_qt5}/QtMultimedia.*
%{py3_site_qt5}/QtMultimediaWidgets.*
%{py3_site_qt5}/QtNfc.*
%{py3_site_qt5}/QtPositioning.*
%{py3_site_qt5}/QtQml.*
%{py3_site_qt5}/QtQuick.*
%{py3_site_qt5}/QtQuickWidgets.*
%{py3_site_qt5}/QtSensors.*
%{py3_site_qt5}/QtSerialPort.*
%{py3_site_qt5}/QtSvg.*
%{py3_site_qt5}/QtWebChannel.*
%{py3_site_qt5}/QtWebSockets.*
%{py3_site_qt5}/QtX11Extras.*
%{py3_site_qt5}/QtXmlPatterns.*

%files -n python%{python3_pkgversion}-qt5-base
%license LICENSE
%doc NEWS README
%{_bindir}/pylupdate5
%{_bindir}/pyrcc5
%{_bindir}/pyuic5
%{python3_dbus_dir}/pyqt5.abi3.so
%dir %{py3_site_qt5}/
%{py3_site_qt5}-%{version}.dist-info
%{py3_site_qt5}/__pycache__/__init__.*
%{py3_site_qt5}/__init__.py*
%{py3_site_qt5}/Qt.*
%{py3_site_qt5}/QtCore.*
%{py3_site_qt5}/QtDBus.*
%{py3_site_qt5}/QtGui.*
%{py3_site_qt5}/QtNetwork.*
%{py3_site_qt5}/QtOpenGL.*
%{py3_site_qt5}/QtPrintSupport.*
%{py3_site_qt5}/QtSql.*
%{py3_site_qt5}/QtTest.*
%{py3_site_qt5}/QtWidgets.*
%{py3_site_qt5}/QtXml.*
%{py3_site_qt5}/_QOpenGLFunctions_2_0.*
%{py3_site_qt5}/_QOpenGLFunctions_2_1.*
%{py3_site_qt5}/_QOpenGLFunctions_4_1_Core.*
%{py3_site_qt5}/uic/
%{py3_site_qt5}/pylupdate.abi3.so
%{py3_site_qt5}/pylupdate_main.py*
%{py3_site_qt5}/__pycache__/pylupdate_main*
%{py3_site_qt5}/pyrcc.abi3.so
%{py3_site_qt5}/pyrcc_main.py*
%{py3_site_qt5}/__pycache__/pyrcc_main*
%{py3_site_qt5}/py.typed
%{py3_site_qt5}/sip.pyi
%{_qt5_plugindir}/PyQt5/
%{_qt5_plugindir}/designer/libpyqt5.so

%if %{with webengine}
%files -n python%{python3_pkgversion}-qt5-webengine
%{py3_site_qt5}/QtWebEngine.*
%{py3_site_qt5}/QtWebEngineCore.*
%{py3_site_qt5}/QtWebEngineWidgets.*
%endif

%if %{with webkit}
%files -n python%{python3_pkgversion}-qt5-webkit
%{py3_site_qt5}/QtWebKit.*
%{py3_site_qt5}/QtWebKitWidgets.*
%endif

%files -n python%{python3_pkgversion}-qt5-devel
%doc examples/
%doc %{_qt5_datadir}/qsci/api/python/PyQt5.api
%{py3_site_qt5}/bindings/
%dir %{_qt5_datadir}/qsci/
%dir %{_qt5_datadir}/qsci/api/
%dir %{_qt5_datadir}/qsci/api/python/

%changelog
* Thu Jan 25 2024 edwardewang <edwardewang@tencent.com> - 5.15.9-5
- Rebuilt for qt5-qtbase 5.15.11

* Thu Sep 21 2023 kianli <kianli@tencent.com> - 5.15.9-4
- Rebuilt for qt5-qt3d 5.15.10

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.9-3
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.9-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 17 2023 Shuo Wang <abushwang@tencent.com> - 5.15.9-1
- update to 5.15.9

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.6-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.6-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Mar 17 2023 Shuo Wang <abushwang@tencent.com> - 5.15.6-1
- initial build
